;												
; D-Verstrker ATmega8							
; Bernhard.Erfurt@gmx.de						
; 12/2019										
;												

;												
; LED ROT blinkt: Programm Check Error			
; LED ROT+GELB blinkt: Interrupt Error			
; LED ROT+GELB+GRN blinkt: WDR Error (nicht in dieser Version)	
;												


; ATmega8 										
.include "m8def.inc"
.include "MACRO.asm"
; PWM											
.equ PWM_A=OCR1AL
.equ PWM_B=OCR1BL
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD
; REGISTER										
.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0
rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   		; Timer0 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp ADCi        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	
;-------------------------------------------------------------------------------
; Unkorrekten Interrupt Aufruf 													
INTERRUPT_ERROR:
	LED_GELB_ON
	LED_ROT_ON
	rcall wait_100ms
	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_OFF
	rcall wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)					; STACK initialisieren								
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	rcall WDR_INITIALISIERUNG				; WDR_INITIALISIERUNG								
	rcall LED_INITIALISIERUNG				; LED_INITIALISIERUNG								
	rcall ADC_INITIALISIERUNG				; ADC_INITIALISIERUNG								
	rcall TIMER1_PWM						; TIMER1_PWM										
	rcall SLEEP_INITIALISIEREN				; SLEEP												
	sei										; Interrupts freigeben								

;-------------------------------------------------------------------------------
LOOP:
	WDR										; Watch-Dog-RESET	
	rcall ADC0_TEMP
	out PWM_A,temp
	rcall LED_TEMP


	rcall ADC1_TEMP
	out PWM_B,temp
	rcall LED_TEMP
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEMP:
.equ GRUEN=2
.equ GELB =30
.equ ROT =100
	cpi temp,(127+ROT)
	brsh LED_3
	cpi temp,(127+GELB)
	brsh LED_2
	cpi temp,(127+GRUEN)
	brsh LED_1

	cpi temp,(127-ROT)
	brlo LED_3
	cpi temp,(127-GELB)
	brlo LED_2
	cpi temp,(127-GRUEN)
	brlo LED_1

	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_OFF
	ret
;-------------------------------------------------------------------------------
LED_1:
	LED_GRUEN_ON
	LED_GELB_OFF
	LED_ROT_OFF
	ret
;-------------------------------------------------------------------------------
LED_2:
	LED_GRUEN_ON
	LED_GELB_ON
	LED_ROT_OFF
	ret
;-------------------------------------------------------------------------------
LED_3:
	LED_GRUEN_ON
	LED_GELB_ON
	LED_ROT_ON
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "ADC.asm"
.include "TIMER.asm"
.include "SONSTIGES.asm"
.include "WAIT.asm"

